# -*- coding: utf-8 -*-

"""
/***************************************************************************
 TlugProcessing
                                 GDAL_Raster
 TLUG Algorithms
                              -------------------
        begin                : 2018-11-28
        copyright            : (C) 2017 by Thüringer Landesanstalt für Umwelt und Geologie (TLUG)
        email                : Michael.Kuerbs@tlug.thueringen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'Michael Kürbs'
__date__ = '2017-11-28'
__copyright__ = '(C) 2017 Michael Kürbs by Thüringer Landesanstalt für Umwelt und Geologie (TLUG)'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

from osgeo import gdal
from osgeo.gdalconst import GA_ReadOnly

class GDAL_Raster():

	dataset = None
	geotransform = None
	layerCount = None
	bandCount = None
	xWidth = None
	yWidth= None
	metaData = None
	bandList=[]
	
	
	def init(self, rasterFileName):
	    #GDAL
        self.dataset = gdal.Open(rasterFileName, GA_ReadOnly)
        self.geotransform = self.dataset.GetGeoTransform()
		self.layerCount=self.dataset.GetLayerCount()
		self.bandCount=self.dataset.GetRasterCount()
		self.xWidth=self.dataset.GetRasterXSize()
		self.yWidth=self.dataset.GetRasterYSize()
		self.metaData=self.dataset.GetMetadata()
		=self.dataset.GetDriverName()
        
		
		
		for i in range(bandCount):
			band = dataset.GetRasterBand(i)
			bandList.append(band)
			#bandtype = gdal.GetDataTypeName(band.DataType)
			#nodata = band.GetNoDataValue()
	
	def getBandType(self, bandNum):
		bandType = gdal.GetDataTypeName(self.bandList[bandNum].DataType)
		return bandType
		
	def getBandNoData(self, bandNum):
		noData = self.bandList[bandNum].GetNoDataValue()
		return noData
		
	